/*
 * Copyright (C) by Argonne National Laboratory
 *     See COPYRIGHT in top-level directory
 *
 * DO NOT EDIT: AUTOMATICALLY GENERATED FILE !!
 */

#include <stdio.h>
#include <stdlib.h>
#include <wchar.h>
#include "yaksi.h"
#include "yaksu.h"
#include "yaksuri_cudai.h"
#include "yaksuri_cudai_populate_pupfns.h"
#include "yaksuri_cudai_pup.h"

int yaksuri_cudai_populate_pupfns_resized_hindexed(yaksi_type_s * type)
{
    int rc = YAKSA_SUCCESS;
    yaksuri_cudai_type_s *cuda = (yaksuri_cudai_type_s *) type->backend.cuda.priv;
    
    char *str = getenv("YAKSA_ENV_MAX_NESTING_LEVEL");
    int max_nesting_level;
    if (str) {
        max_nesting_level = atoi(str);
    } else {
        max_nesting_level = YAKSI_ENV_DEFAULT_NESTING_LEVEL;
    }
    
    switch (type->u.resized.child->u.hindexed.child->kind) {
        case YAKSI_TYPE_KIND__HVECTOR:
        switch (type->u.resized.child->u.hindexed.child->u.hvector.child->kind) {
            case YAKSI_TYPE_KIND__BUILTIN:
            switch (type->u.resized.child->u.hindexed.child->u.hvector.child->id) {
                case YAKSA_TYPE__CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_char;
                }
                break;
                case YAKSA_TYPE__WCHAR_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_wchar_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_wchar_t;
                }
                break;
                case YAKSA_TYPE__INT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int;
                }
                break;
                case YAKSA_TYPE__SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_short;
                }
                break;
                case YAKSA_TYPE__LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_long;
                }
                break;
                case YAKSA_TYPE__LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_long_long;
                }
                break;
                case YAKSA_TYPE__INT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int8_t;
                }
                break;
                case YAKSA_TYPE__INT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int16_t;
                }
                break;
                case YAKSA_TYPE__INT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int32_t;
                }
                break;
                case YAKSA_TYPE__INT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int64_t;
                }
                break;
                case YAKSA_TYPE__FLOAT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_float;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_float;
                }
                break;
                case YAKSA_TYPE__DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_double;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_char;
                }
                break;
                case YAKSA_TYPE__UINT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int8_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_long;
                }
                break;
                case YAKSA_TYPE__LONG_DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_double;
                }
                break;
                case YAKSA_TYPE__BYTE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int8_t;
                }
                break;
                case YAKSA_TYPE__UINT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int32_t;
                }
                break;
                case YAKSA_TYPE__UINT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int64_t;
                }
                break;
                case YAKSA_TYPE__UINT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int16_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_long_long;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_short;
                }
                break;
                case YAKSA_TYPE__UNSIGNED:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hvector_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hvector_int;
                }
                break;
                default:
                    break;
            }
            break;
            default:
                break;
        }
        break;
        case YAKSI_TYPE_KIND__BLKHINDX:
        switch (type->u.resized.child->u.hindexed.child->u.blkhindx.child->kind) {
            case YAKSI_TYPE_KIND__BUILTIN:
            switch (type->u.resized.child->u.hindexed.child->u.blkhindx.child->id) {
                case YAKSA_TYPE__CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_char;
                }
                break;
                case YAKSA_TYPE__WCHAR_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_wchar_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_wchar_t;
                }
                break;
                case YAKSA_TYPE__INT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int;
                }
                break;
                case YAKSA_TYPE__SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_short;
                }
                break;
                case YAKSA_TYPE__LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_long;
                }
                break;
                case YAKSA_TYPE__LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_long_long;
                }
                break;
                case YAKSA_TYPE__INT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int8_t;
                }
                break;
                case YAKSA_TYPE__INT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int16_t;
                }
                break;
                case YAKSA_TYPE__INT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int32_t;
                }
                break;
                case YAKSA_TYPE__INT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int64_t;
                }
                break;
                case YAKSA_TYPE__FLOAT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_float;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_float;
                }
                break;
                case YAKSA_TYPE__DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_double;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_char;
                }
                break;
                case YAKSA_TYPE__UINT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int8_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_long;
                }
                break;
                case YAKSA_TYPE__LONG_DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_double;
                }
                break;
                case YAKSA_TYPE__BYTE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int8_t;
                }
                break;
                case YAKSA_TYPE__UINT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int32_t;
                }
                break;
                case YAKSA_TYPE__UINT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int64_t;
                }
                break;
                case YAKSA_TYPE__UINT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int16_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_long_long;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_short;
                }
                break;
                case YAKSA_TYPE__UNSIGNED:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_blkhindx_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_blkhindx_int;
                }
                break;
                default:
                    break;
            }
            break;
            default:
                break;
        }
        break;
        case YAKSI_TYPE_KIND__HINDEXED:
        switch (type->u.resized.child->u.hindexed.child->u.hindexed.child->kind) {
            case YAKSI_TYPE_KIND__BUILTIN:
            switch (type->u.resized.child->u.hindexed.child->u.hindexed.child->id) {
                case YAKSA_TYPE__CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_char;
                }
                break;
                case YAKSA_TYPE__WCHAR_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_wchar_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_wchar_t;
                }
                break;
                case YAKSA_TYPE__INT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int;
                }
                break;
                case YAKSA_TYPE__SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_short;
                }
                break;
                case YAKSA_TYPE__LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_long;
                }
                break;
                case YAKSA_TYPE__LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_long_long;
                }
                break;
                case YAKSA_TYPE__INT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int8_t;
                }
                break;
                case YAKSA_TYPE__INT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int16_t;
                }
                break;
                case YAKSA_TYPE__INT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int32_t;
                }
                break;
                case YAKSA_TYPE__INT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int64_t;
                }
                break;
                case YAKSA_TYPE__FLOAT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_float;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_float;
                }
                break;
                case YAKSA_TYPE__DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_double;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_char;
                }
                break;
                case YAKSA_TYPE__UINT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int8_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_long;
                }
                break;
                case YAKSA_TYPE__LONG_DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_double;
                }
                break;
                case YAKSA_TYPE__BYTE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int8_t;
                }
                break;
                case YAKSA_TYPE__UINT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int32_t;
                }
                break;
                case YAKSA_TYPE__UINT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int64_t;
                }
                break;
                case YAKSA_TYPE__UINT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int16_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_long_long;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_short;
                }
                break;
                case YAKSA_TYPE__UNSIGNED:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_hindexed_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_hindexed_int;
                }
                break;
                default:
                    break;
            }
            break;
            default:
                break;
        }
        break;
        case YAKSI_TYPE_KIND__CONTIG:
        switch (type->u.resized.child->u.hindexed.child->u.contig.child->kind) {
            case YAKSI_TYPE_KIND__BUILTIN:
            switch (type->u.resized.child->u.hindexed.child->u.contig.child->id) {
                case YAKSA_TYPE__CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_char;
                }
                break;
                case YAKSA_TYPE__WCHAR_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_wchar_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_wchar_t;
                }
                break;
                case YAKSA_TYPE__INT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int;
                }
                break;
                case YAKSA_TYPE__SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_short;
                }
                break;
                case YAKSA_TYPE__LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_long;
                }
                break;
                case YAKSA_TYPE__LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_long_long;
                }
                break;
                case YAKSA_TYPE__INT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int8_t;
                }
                break;
                case YAKSA_TYPE__INT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int16_t;
                }
                break;
                case YAKSA_TYPE__INT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int32_t;
                }
                break;
                case YAKSA_TYPE__INT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int64_t;
                }
                break;
                case YAKSA_TYPE__FLOAT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_float;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_float;
                }
                break;
                case YAKSA_TYPE__DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_double;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_char;
                }
                break;
                case YAKSA_TYPE__UINT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int8_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_long;
                }
                break;
                case YAKSA_TYPE__LONG_DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_double;
                }
                break;
                case YAKSA_TYPE__BYTE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int8_t;
                }
                break;
                case YAKSA_TYPE__UINT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int32_t;
                }
                break;
                case YAKSA_TYPE__UINT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int64_t;
                }
                break;
                case YAKSA_TYPE__UINT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int16_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_long_long;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_short;
                }
                break;
                case YAKSA_TYPE__UNSIGNED:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_contig_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_contig_int;
                }
                break;
                default:
                    break;
            }
            break;
            default:
                break;
        }
        break;
        case YAKSI_TYPE_KIND__RESIZED:
        switch (type->u.resized.child->u.hindexed.child->u.resized.child->kind) {
            case YAKSI_TYPE_KIND__BUILTIN:
            switch (type->u.resized.child->u.hindexed.child->u.resized.child->id) {
                case YAKSA_TYPE__CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_char;
                }
                break;
                case YAKSA_TYPE__WCHAR_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_wchar_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_wchar_t;
                }
                break;
                case YAKSA_TYPE__INT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int;
                }
                break;
                case YAKSA_TYPE__SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_short;
                }
                break;
                case YAKSA_TYPE__LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_long;
                }
                break;
                case YAKSA_TYPE__LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_long_long;
                }
                break;
                case YAKSA_TYPE__INT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int8_t;
                }
                break;
                case YAKSA_TYPE__INT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int16_t;
                }
                break;
                case YAKSA_TYPE__INT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int32_t;
                }
                break;
                case YAKSA_TYPE__INT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int64_t;
                }
                break;
                case YAKSA_TYPE__FLOAT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_float;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_float;
                }
                break;
                case YAKSA_TYPE__DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_double;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_CHAR:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_char;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_char;
                }
                break;
                case YAKSA_TYPE__UINT8_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int8_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_long;
                }
                break;
                case YAKSA_TYPE__LONG_DOUBLE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_double;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_double;
                }
                break;
                case YAKSA_TYPE__BYTE:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int8_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int8_t;
                }
                break;
                case YAKSA_TYPE__UINT32_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int32_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int32_t;
                }
                break;
                case YAKSA_TYPE__UINT64_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int64_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int64_t;
                }
                break;
                case YAKSA_TYPE__UINT16_T:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int16_t;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int16_t;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_LONG_LONG:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_long_long;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_long_long;
                }
                break;
                case YAKSA_TYPE__UNSIGNED_SHORT:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_short;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_short;
                }
                break;
                case YAKSA_TYPE__UNSIGNED:
                if (max_nesting_level >= 3) {
                    cuda->pack = yaksuri_cudai_pack_resized_hindexed_resized_int;
                    cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_resized_int;
                }
                break;
                default:
                    break;
            }
            break;
            default:
                break;
        }
        break;
        case YAKSI_TYPE_KIND__BUILTIN:
        switch (type->u.resized.child->u.hindexed.child->id) {
            case YAKSA_TYPE__CHAR:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_char;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_char;
            }
            break;
            case YAKSA_TYPE__WCHAR_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_wchar_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_wchar_t;
            }
            break;
            case YAKSA_TYPE__INT:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int;
            }
            break;
            case YAKSA_TYPE__SHORT:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_short;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_short;
            }
            break;
            case YAKSA_TYPE__LONG:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_long;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_long;
            }
            break;
            case YAKSA_TYPE__LONG_LONG:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_long_long;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_long_long;
            }
            break;
            case YAKSA_TYPE__INT8_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int8_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int8_t;
            }
            break;
            case YAKSA_TYPE__INT16_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int16_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int16_t;
            }
            break;
            case YAKSA_TYPE__INT32_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int32_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int32_t;
            }
            break;
            case YAKSA_TYPE__INT64_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int64_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int64_t;
            }
            break;
            case YAKSA_TYPE__FLOAT:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_float;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_float;
            }
            break;
            case YAKSA_TYPE__DOUBLE:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_double;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_double;
            }
            break;
            case YAKSA_TYPE__UNSIGNED_CHAR:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_char;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_char;
            }
            break;
            case YAKSA_TYPE__UINT8_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int8_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int8_t;
            }
            break;
            case YAKSA_TYPE__UNSIGNED_LONG:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_long;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_long;
            }
            break;
            case YAKSA_TYPE__LONG_DOUBLE:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_double;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_double;
            }
            break;
            case YAKSA_TYPE__BYTE:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int8_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int8_t;
            }
            break;
            case YAKSA_TYPE__UINT32_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int32_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int32_t;
            }
            break;
            case YAKSA_TYPE__UINT64_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int64_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int64_t;
            }
            break;
            case YAKSA_TYPE__UINT16_T:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int16_t;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int16_t;
            }
            break;
            case YAKSA_TYPE__UNSIGNED_LONG_LONG:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_long_long;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_long_long;
            }
            break;
            case YAKSA_TYPE__UNSIGNED_SHORT:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_short;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_short;
            }
            break;
            case YAKSA_TYPE__UNSIGNED:
            if (max_nesting_level >= 2) {
                cuda->pack = yaksuri_cudai_pack_resized_hindexed_int;
                cuda->unpack = yaksuri_cudai_unpack_resized_hindexed_int;
            }
            break;
            default:
                break;
        }
        break;
        default:
            break;
    }
    
    return rc;
}
