/*
 * Copyright (C) by Argonne National Laboratory
 *     See COPYRIGHT in top-level directory
 *
 * DO NOT EDIT: AUTOMATICALLY GENERATED FILE !!
 */

#include <stdio.h>
#include <stdlib.h>
#include <wchar.h>
#include "yaksi.h"
#include "yaksu.h"
#include "yaksuri_seqi.h"
#include "yaksuri_seqi_populate_pupfns.h"
#include "yaksuri_seqi_pup.h"

int yaksuri_seqi_populate_pupfns_resized_builtin(yaksi_type_s * type)
{
    int rc = YAKSA_SUCCESS;
    yaksuri_seqi_type_s *seq = (yaksuri_seqi_type_s *) type->backend.seq.priv;
    
    char *str = getenv("YAKSA_ENV_MAX_NESTING_LEVEL");
    int max_nesting_level;
    if (str) {
        max_nesting_level = atoi(str);
    } else {
        max_nesting_level = YAKSI_ENV_DEFAULT_NESTING_LEVEL;
    }
    
    switch (type->u.resized.child->id) {
        case YAKSA_TYPE__CHAR:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_char;
            seq->unpack = yaksuri_seqi_unpack_resized_char;
        }
        break;
        case YAKSA_TYPE__WCHAR_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_wchar_t;
            seq->unpack = yaksuri_seqi_unpack_resized_wchar_t;
        }
        break;
        case YAKSA_TYPE__INT:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int;
            seq->unpack = yaksuri_seqi_unpack_resized_int;
        }
        break;
        case YAKSA_TYPE__SHORT:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_short;
            seq->unpack = yaksuri_seqi_unpack_resized_short;
        }
        break;
        case YAKSA_TYPE__LONG:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_long;
            seq->unpack = yaksuri_seqi_unpack_resized_long;
        }
        break;
        case YAKSA_TYPE__LONG_LONG:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_long_long;
            seq->unpack = yaksuri_seqi_unpack_resized_long_long;
        }
        break;
        case YAKSA_TYPE__INT8_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int8_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int8_t;
        }
        break;
        case YAKSA_TYPE__INT16_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int16_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int16_t;
        }
        break;
        case YAKSA_TYPE__INT32_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int32_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int32_t;
        }
        break;
        case YAKSA_TYPE__INT64_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int64_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int64_t;
        }
        break;
        case YAKSA_TYPE__FLOAT:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_float;
            seq->unpack = yaksuri_seqi_unpack_resized_float;
        }
        break;
        case YAKSA_TYPE__DOUBLE:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_double;
            seq->unpack = yaksuri_seqi_unpack_resized_double;
        }
        break;
        case YAKSA_TYPE__LONG_DOUBLE:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_long_double;
            seq->unpack = yaksuri_seqi_unpack_resized_long_double;
        }
        break;
        case YAKSA_TYPE__UNSIGNED_LONG_LONG:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_long_long;
            seq->unpack = yaksuri_seqi_unpack_resized_long_long;
        }
        break;
        case YAKSA_TYPE__UINT8_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int8_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int8_t;
        }
        break;
        case YAKSA_TYPE__UINT64_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int64_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int64_t;
        }
        break;
        case YAKSA_TYPE__UINT16_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int16_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int16_t;
        }
        break;
        case YAKSA_TYPE__UNSIGNED_CHAR:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_char;
            seq->unpack = yaksuri_seqi_unpack_resized_char;
        }
        break;
        case YAKSA_TYPE__UNSIGNED_LONG:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_long;
            seq->unpack = yaksuri_seqi_unpack_resized_long;
        }
        break;
        case YAKSA_TYPE__UNSIGNED_SHORT:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_short;
            seq->unpack = yaksuri_seqi_unpack_resized_short;
        }
        break;
        case YAKSA_TYPE__UNSIGNED:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int;
            seq->unpack = yaksuri_seqi_unpack_resized_int;
        }
        break;
        case YAKSA_TYPE__BYTE:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int8_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int8_t;
        }
        break;
        case YAKSA_TYPE__UINT32_T:
        if (max_nesting_level >= 1) {
            seq->pack = yaksuri_seqi_pack_resized_int32_t;
            seq->unpack = yaksuri_seqi_unpack_resized_int32_t;
        }
        break;
        default:
            break;
    }
    
    return rc;
}
